
This is a difference file for the WAIS source, version 8b5, as available
via ftp to ftp.think.com.  It includes changes for boolean operators,
literal string matches, partial word matches, and biology specific
needs.  See the ftp/gopher archive at ftp.bio.indiana.edu, /util/wais/iubio*
for more information.

At least a couple of problems remain:
  The wais-8b5 code will not properly index words that occur more
  than 32,000 times.  The Genbank biology databank that I serve
  here has > 80,000 records, and some important index words occur
  more than this limit.  The wais release 8b3 was amenable to
  uping this limit, but not the w8b5.  I'll continue to look
  for this problem.

  The partial word matching addition of mine is imperfect -- it
  misses some words that should match.  Anyone who can look into
  this and help out, I'd appreciate it.  I'll also work on this
  as time permits.


You can apply this patch with Larry Wall's patch program (available at 
many unix ftp sites), in this way, at the directory containing gopher1.01/
   % patch -p < bintypes.patch

-- Don Gilbert (gilbertd@bio.indiana.edu)


diff -bwcr wais-8-b5/Makefile w8b5bio/Makefile
*** wais-8-b5/Makefile	Mon Oct 12 12:13:10 1992
--- w8b5bio/Makefile	Wed Oct 28 08:44:40 1992
***************
*** 41,47 ****
  RANLIB = ranlib
  
  # on IBM RS6000 this should be c89.
! CC = cc
  
  # set this for your site.  This syntax only works in SunOS
  # for other UNIX-like OS's set this to this directory.
--- 41,48 ----
  RANLIB = ranlib
  
  # on IBM RS6000 this should be c89.
! #CC = cc
! CC = gcc
  
  # set this for your site.  This syntax only works in SunOS
  # for other UNIX-like OS's set this to this directory.
***************
*** 61,71 ****
  # for relevance feedaback in the search engine, add -DRELEVANCE_FEEDBACK
  # USG for Unix Dirent in lib
  # for SGIs running IRIX 4.0.1, add -cckr
! CFLAGS = -g -I$(SUPDIR) -DSECURE_SERVER -DRELEVANCE_FEEDBACK -DUSG
  
  MAKE = make -k 
  
! default: config.h lib ir ui bin doc x tags
  	@echo "Welcome to WAIS"
  
  config.h: config
--- 62,80 ----
  # for relevance feedaback in the search engine, add -DRELEVANCE_FEEDBACK
  # USG for Unix Dirent in lib
  # for SGIs running IRIX 4.0.1, add -cckr
! #   dgg additions
! # LITERAL == waisserver, search for "literal strings"
! # BOOLEANS == waisserver, search with boolean AND, NOT operators
! # PARTIALWORD == waisserver, search for partial words, hum* matches human, hummingbird, ...
! # BIO == waisindex, waisserver changes including symbol indexing & search & bio data formats
! #
! #CFLAGS = -g -I$(SUPDIR) -DSECURE_SERVER -DRELEVANCE_FEEDBACK -DUSG
! CFLAGS = -g -I$(SUPDIR) -DSECURE_SERVER -DRELEVANCE_FEEDBACK -DUSG -DBIO -DBOOLEANS -DPARTIALWORD -DLITERAL
  
  MAKE = make -k 
  
! #default: config.h lib ir ui bin doc x tags
! default: config.h lib ir ui bin doc x 
  	@echo "Welcome to WAIS"
  
  config.h: config
Common subdirectories: wais-8-b5/bin and w8b5bio/bin
Common subdirectories: wais-8-b5/doc and w8b5bio/doc
Common subdirectories: wais-8-b5/ir and w8b5bio/ir
Common subdirectories: wais-8-b5/lib and w8b5bio/lib
Common subdirectories: wais-8-b5/ui and w8b5bio/ui
Common subdirectories: wais-8-b5/wais-sources and w8b5bio/wais-sources
Common subdirectories: wais-8-b5/x and w8b5bio/x
diff -bwcr wais-8-b5/doc/Makefile w8b5bio/doc/Makefile
*** wais-8-b5/doc/Makefile	Fri Nov 22 18:27:26 1991
--- w8b5bio/doc/Makefile	Sat Oct 24 11:22:55 1992
***************
*** 36,41 ****
--- 36,42 ----
  
  ../wais-sources/wais-docs.dct: $(text)
  	../bin/waisindex -d ../wais-sources/wais-docs -t text *.txt
+ 	../bin/waisindex -d ../wais-sources/test -t bio *.bio
  
  clean:
  	$(RM) *~
Common subdirectories: wais-8-b5/doc/manl and w8b5bio/doc/manl
Only in w8b5bio/doc: stop.test
Only in w8b5bio/doc: test.bio
diff -bwcr wais-8-b5/ir/Makefile w8b5bio/ir/Makefile
*** wais-8-b5/ir/Makefile	Sun May 10 16:42:23 1992
--- w8b5bio/ir/Makefile	Sun Nov  8 19:25:02 1992
***************
*** 173,179 ****
  
  # C Compiler.  Use either cc or gcc.  Comment this out in release to
  # inherit from top level.
! CC = cc
  
  # Compiler & linker flags.
  # Compiler debug flag.  Use -g for debugging, -O for optimization.
--- 173,180 ----
  
  # C Compiler.  Use either cc or gcc.  Comment this out in release to
  # inherit from top level.
! #CC = cc
! CC = gcc
  
  # Compiler & linker flags.
  # Compiler debug flag.  Use -g for debugging, -O for optimization.
***************
*** 181,187 ****
  # for System V add -DSYSV 
  # for XENIX add -M3e -Zi
  # -DSECURE_SERVER for waisserver to setuid to uucp after startup.
! CFLAGS = -g -DSECURE_SERVER -DRELEVANCE_FEEDBACK
  
  # dealing with taking an intenet name and resolving it.  
  # set to -lresolv or nothing
--- 182,196 ----
  # for System V add -DSYSV 
  # for XENIX add -M3e -Zi
  # -DSECURE_SERVER for waisserver to setuid to uucp after startup.
! #
! # -- dgg additions for biology data
! # -DPARTIALWORD (waisserver) for partial word matches, hum* matches human, hummingbird, ...
! # -DBOOLEANS (waisserver) for boolean AND, NOT patches (dgg)
! # -DLITERAL (waisserver) search for "literal strings" (dgg)
! # -DBIO for biology source patches, including symbol usage (dgg, 12oct92)
! #
! CFLAGS = -g -DSECURE_SERVER -DRELEVANCE_FEEDBACK -DBIO -DBOOLEANS -DPARTIALWORD -DLITERAL
! #CFLAGS = -g -DSECURE_SERVER -DRELEVANCE_FEEDBACK
  
  # dealing with taking an intenet name and resolving it.  
  # set to -lresolv or nothing
diff -bwcr wais-8-b5/ir/cutil.c w8b5bio/ir/cutil.c
*** wais-8-b5/ir/cutil.c	Thu Apr 30 11:03:35 1992
--- w8b5bio/ir/cutil.c	Sat Oct 31 13:09:27 1992
***************
*** 288,299 ****
  
  /*----------------------------------------------------------------------*/
  
! typedef long (longfunc) _AP((long c));
  
  char*
  strtokf(s1,isDelimiter)
  char* s1;
! longfunc *isDelimiter; /* really *isDelimiter() */
  
  /* This function is exactly like strtok, except that instead of passing a 
     delimiter string, you pass a function that decides if a character is 
--- 288,324 ----
  
  /*----------------------------------------------------------------------*/
  
! boolean 
! wordbreak_notalnum(ch)		/* dgg */
! long   ch;
! {   
!     return( !isalnum(ch));
! }
  
+ boolean 
+ wordbreak_notgraph(ch)		/* dgg */
+ long   ch;
+ {   
+     return( !isgraph(ch));
+ }
+ 
+ boolean wordbreak_user(c)
+ long c;
+ {
+   if ( (gDelimiters[0] != '\0') && (strchr(gDelimiters, (char) c) != NULL) )
+     return(IS_DELIMITER);  
+   else if (isgraph(c))
+     return(NOT_DELIMITER);
+   else
+     return(IS_DELIMITER);
+ }
+ 
+ typedef boolean (boolfunc) _AP((long c));
+ 
  char*
  strtokf(s1,isDelimiter)
  char* s1;
! boolfunc *isDelimiter; /* really *isDelimiter() */
  
  /* This function is exactly like strtok, except that instead of passing a 
     delimiter string, you pass a function that decides if a character is 
***************
*** 303,309 ****
   */
  {
    static char* searchStr = NULL;
!   static longfunc *delimiterFunc;
    long i;
    char* startTok = NULL;
  
--- 328,334 ----
   */
  {
    static char* searchStr = NULL;
!   static boolfunc *delimiterFunc;
    long i;
    char* startTok = NULL;
  
diff -bwcr wais-8-b5/ir/cutil.h w8b5bio/ir/cutil.h
*** wais-8-b5/ir/cutil.h	Sat Mar  7 22:40:03 1992
--- w8b5bio/ir/cutil.h	Sat Oct 31 19:55:32 1992
***************
*** 39,44 ****
--- 39,45 ----
  #endif
  
  #define MAX_FILENAME_LEN 255
+ #define MAX_DELIMITERS 256
  
  #ifdef ANSI_LIKE
  #ifndef EXIT_SUCCESS /* only include it if not already included */
***************
*** 122,132 ****
  
  char* 	s_strdup _AP((char* s));
  
! char*	strtokf _AP((char* s1,long (*isDelimiter)(long c))); 
  char*   strtokf_isalnum _AP((char* s1));
  
! #define IS_DELIMITER	1
! #define	NOT_DELIMITER	!IS_DELIMITER
  
  #ifdef ANSI_LIKE	/* use ansi */
  long		cprintf _AP((boolean print,char* format,...));
--- 123,137 ----
  
  char* 	s_strdup _AP((char* s));
  
! boolean wordbreak_notalnum _AP(( long ch));  /* dgg */
! boolean wordbreak_notgraph _AP(( long ch));	 /* dgg */
! boolean wordbreak_user _AP(( long ch));	 /* dgg, uses gDelimiters */
! 
! char*	strtokf _AP((char* s1,boolean (*isDelimiter)(long c))); 
  char* strtokf_isalnum _AP((char* s1));
  
! #define IS_DELIMITER	true
! #define	NOT_DELIMITER	false
  
  #ifdef ANSI_LIKE	/* use ansi */
  long		cprintf _AP((boolean print,char* format,...));
***************
*** 182,191 ****
--- 187,198 ----
  long wais_pid = 0;
  long log_line = 0;
  long wais_log_level = 10;
+ char gDelimiters[MAX_DELIMITERS];  /* dgg */
  #else
  extern long wais_pid;
  extern long log_line;
  extern wais_log_level;
+ extern char gDelimiters[];  /* dgg */
  #endif /* _C_C_util_
  
  #ifdef __cplusplus
diff -bwcr wais-8-b5/ir/irbuild.c w8b5bio/ir/irbuild.c
*** wais-8-b5/ir/irbuild.c	Sun May 10 16:48:16 1992
--- w8b5bio/ir/irbuild.c	Sun Nov  8 18:59:38 1992
***************
*** 97,104 ****
--- 97,109 ----
  #include "ircfiles.h"
  #include "version.h"
  #include "irext.h"
+ #include "stoplist.h"	/* dgg */
  
+ #ifdef BIO
+ #define INDEXER_DATE "31 Oct 1992, bio patch"
+ #else
  #define INDEXER_DATE "Sun May 10 1992"
+ #endif
  
  /* for reporting errors, in WAIStation it is defined in CRetrievalApp.c */
  
***************
*** 125,130 ****
--- 130,139 ----
    fprintf(stderr,"          [-contents] /* Index the contents: this is good for types that\n");
    fprintf(stderr,"                         inhibit the indexing of the contents (like gif). /*\n");
    fprintf(stderr,"          [-nocontents] /* Index only the filename, not the contents /*\n");
+ #ifdef BIO
+   fprintf(stderr,"          [-stop stoplist_filename] /* file of common words to ignore */\n");
+   fprintf(stderr,"          [-delim delimiters] /* list of word delimiter symbols */\n");
+ #endif 
    fprintf(stderr,"          [-cmmem  mem%] /* percent of CM memory (CM code only) */\n");
    fprintf(stderr,"          [-T  type] /* type becomes the \"TYPE\" of the document. */\n");
    fprintf(stderr,"          [-t	/* format of the file. if none then each file is a document */\n");
***************
*** 158,163 ****
--- 167,184 ----
    fprintf(stderr,"           | objc /* objective-C .h and .m files */\n");
  #endif /* def NeXT */
    fprintf(stderr,"           | tiff /* tiff files, only indexes the filename */\n");
+ #ifdef BIO
+   fprintf(stderr,"           | genbank  /* GenBank flatfile format */\n");
+   fprintf(stderr,"           | embl     /* EMBL flatfile format */\n");
+   fprintf(stderr,"           | pir     /* PIR flatfile format */\n");
+   fprintf(stderr,"           | prositedoc /* Prosite protein doc format */\n");
+   fprintf(stderr,"           | prositedat /* Prosite protein dat format */\n");
+   fprintf(stderr,"           | biojournal /* Bio journal TOC on bionet.journals */\n");
+   fprintf(stderr,"           | redbook  /* Drosophila redbook text */\n");
+   fprintf(stderr,"           | flybase  /* Drosophila Ashburner data files */\n");
+   fprintf(stderr,"           | flystock  /* Drosophila stock lists */\n");
+   fprintf(stderr,"           | din      /* Drosophila Info. Newsletter */\n");
+ #endif
    fprintf(stderr,"          ] filename filename ...\n");
  }
  
***************
*** 166,171 ****
--- 187,193 ----
  
  extern boolean index_contents;
  
+ 
  /* This is the MAIN for building an index.
   */
  void
***************
*** 178,187 ****
    char **argv_copy = argv;
    char *next_argument;
    char index_filename[1000];
-   boolean (*separator_function)();
-   void (*header_function)();
-   void (*finish_header_function)();
-   long (*date_function)();
    boolean adding_to_existing_index = false;
    boolean traverse_directory = false;
    boolean word_positions = false;
--- 200,205 ----
***************
*** 197,216 ****
    boolean make_catalog = true;
    char data_filename[MAXPATHLEN];
    char *typename = NULL;  /* this is what the user said */
-   char *type = NULL;      /* this is the type stored with the db */
    long start_of_filenames;
    long hashtable_size = 1L<<16;
    long flush_after_n_words = 300000;
    char *command_name;
  
!   next_argument = next_arg(&argc, &argv);
!   separator_function = NULL; /* initailize to nil */
    header_function = NULL;
    date_function = NULL;
    finish_header_function = NULL;
!   type = "TEXT"; /* default to text */
    typename = "Text"; 
  
    command_name = next_argument;
  
    logfile = stderr;
--- 215,261 ----
    boolean make_catalog = true;
    char data_filename[MAXPATHLEN];
    char *typename = NULL;  /* this is what the user said */
    long start_of_filenames;
    long hashtable_size = 1L<<16;
    long flush_after_n_words = 300000;
    char *command_name;
  
!   dataopsrec	dataops;    
!   /*-------------   these go into dataops   
!   boolean (*separator_function)();
!   void (*header_function)();
!   void (*finish_header_function)();
!   long (*date_function)();
!   char *type = NULL;     
!   int minwordlen= 2;	 
!   ---------------*/
!   
!     	/* dgg -- put all of these separate, datatype-specific functions & params into a record! */
!   gDelimiters[0]= '\0'; /* <-- bombs ?? */
!   dataops.separator_function= NULL;
!   dataops.header_function= NULL;
!   dataops.date_function= NULL;
!   dataops.finish_header_function= NULL;
!   dataops.type= "TEXT";
!   dataops.addseparatorwords= false;
!   dataops.extraheaderweight= true;
!   dataops.repeat_weight= 1;
!   dataops.minwordlen= 2;
!   dataops.wordDelimiter= wordbreak_notalnum;
!   dataops.delimiters= gDelimiters;
!   wordDelimiter= wordbreak_notalnum;   
!  
!   /*------
!   separator_function = NULL; 
    header_function = NULL;
    date_function = NULL;
    finish_header_function = NULL;
!   type = "TEXT";  
    typename = "Text"; 
+   -------*/
    
+ 
+   next_argument = next_arg(&argc, &argv);
    command_name = next_argument;
  
    logfile = stderr;
***************
*** 226,231 ****
--- 271,277 ----
  #else
    strcpy(index_filename, "index"); /* in the current directory */
  #endif /* THINK_C */
+   stop_list_file("\0");  	/* dgg */
    
    if(NULL == (next_argument = next_arg(&argc, &argv))){
      fprintf(stderr,"No arguments specified\n");
***************
*** 241,246 ****
--- 287,309 ----
        	}
        strcpy(index_filename, next_argument);
        }
+ #ifdef BIO      
+     else if (0 == strcmp("-stop", next_argument)){		/* dgg, stoplist file */
+       if (NULL == (next_argument = next_arg(&argc, &argv))){
+ 	fprintf(stderr,"Expected filename for the stoplist\n");
+ 	exit(0);
+       	}
+       stop_list_file(next_argument);
+       } 
+     else if (0 == strcmp("-delim", next_argument)){		/* dgg, delimiters */
+       if (NULL == (next_argument = next_arg(&argc, &argv))){
+ 	fprintf(stderr,"Expected the delimiters argument\n");
+ 	exit(0);
+       	}
+       strcpy(gDelimiters, next_argument);
+       } 
+ #endif
+ 
      else if(0 == strcmp("-a", next_argument)){
        adding_to_existing_index = true;
      }
***************
*** 254,260 ****
        export_database = true;
      }
      else if(0 == strcmp("-v", next_argument)){
!       fprintf(stderr,"%s: %s\n", command_name, VERSION, INDEXER_DATE);
      }
      else if (0 == strcmp("-stdin", next_argument)) {
        read_files_from_stdin = true;
--- 317,323 ----
        export_database = true;
      }
      else if(0 == strcmp("-v", next_argument)){
!       fprintf(stderr,"%s: %s %s\n", command_name, VERSION, INDEXER_DATE);
      }
      else if (0 == strcmp("-stdin", next_argument)) {
        read_files_from_stdin = true;
***************
*** 328,335 ****
        if(NULL == (next_argument = next_arg(&argc, &argv)))
  	panic("Expected a file type");
        typename = next_argument;
!       type = next_argument;
!       finish_header_function = filename_finish_header_function;
      }
      else if(0 == strcmp("-contents", next_argument)){
        index_contents = true;
--- 391,398 ----
        if(NULL == (next_argument = next_arg(&argc, &argv)))
  	panic("Expected a file type");
        typename = next_argument;
!       dataops.type = next_argument;
!       dataops.finish_header_function = filename_finish_header_function;
      }
      else if(0 == strcmp("-contents", next_argument)){
        index_contents = true;
